require 'kojak'

class Hello
  extend Kojak::Inspector
  investigate :greet, :this_one_does_nothing

  def greet(attrs = {})
    raise ArgumentError.new("missing name") unless attrs[:name]
    "Hello #{attrs[:name]}!"
  end

  def this_one_does_nothing
  end
end

class HelloTyrion < Hello
  extend Kojak::Inspector
  investigate :greet, :this_one_takes_a_while

  def greet(attrs = {})
    super(:name => "Tyrion Lannister")
  end

  def this_one_takes_a_while
    sleep(1.2)
  end
end

Kojak.investigate!

h1 = Hello.new
h1.greet(:name => "Jon Snow")
h1.greet(:a => 1, :b => 2, :c => 3) rescue nil
h1.this_one_does_nothing

h2 = HelloTyrion.new
h2.greet(:foo => :bar)
h2.this_one_does_nothing
h2.this_one_takes_a_while
