require 'minitest_helper'

describe Kojak::Inspector do
  let(:cls) do
    Class.new(Dummy) do
      extend Kojak::Inspector
      investigate :dummy1
    end
  end

  let(:obj) do
    cls.new
  end

  before do
    cls.extend(Kojak::Inspector)
  end

  describe "investigation" do
    it "should register class in top level" do
      assert Kojak.investigated.include?(cls)
    end

    it "should redefine investigated methods" do
      cls.investigate!
      res = nil
      out, err = capture_subprocess_io do
        res = obj.dummy1(:foo => 1)
      end
      res.must_equal(1)
      err.must_match(/Dummy#dummy1/)
      Kojak.slowlog.last.must_equal("Dummy#dummy1")
    end
  end
end
