require 'minitest_helper'
require 'stringio'

describe Kojak::Printer::Colorized do
  let(:out) do
    StringIO.new
  end

  let(:printer) do
    Kojak::Printer::Colorized.new(out, :red)
  end

  let(:text) do
    "foo"
  end

  describe "write" do
    it "should write given string to the output" do
      printer.write(text)
      out.seek(0)
      out.read.must_equal("\e[31m#{text}\e[0m")
    end
  end

  describe "puts" do
    it "should write given string and newline to the output" do
      printer.expects(:write).with(text + "\n")
      printer.puts(text)
    end
  end
end
